if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_SurveyResult_Survey]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[SurveyResult] DROP CONSTRAINT FK_SurveyResult_Survey
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_SurveySection_Survey]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[SurveySection] DROP CONSTRAINT FK_SurveySection_Survey
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_SurveyQuestion_SurveySection]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[SurveyQuestion] DROP CONSTRAINT FK_SurveyQuestion_SurveySection
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_SurveyQuestionChoice_SurveyQuestion]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[SurveyQuestionChoice] DROP CONSTRAINT FK_SurveyQuestionChoice_SurveyQuestion
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_SurveyQuestion_QuestionType]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[SurveyQuestion] DROP CONSTRAINT FK_SurveyQuestion_QuestionType
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_SurveyQuestionChoice_SurveyChoice]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[SurveyQuestionChoice] DROP CONSTRAINT FK_SurveyQuestionChoice_SurveyChoice
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Survey]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[Survey]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[SurveySection]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[SurveySection]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[SurveyQuestion]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[SurveyQuestion]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[SurveyQuestionType]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[SurveyQuestionType]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[SurveyChoice]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[SurveyChoice]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[SurveyQuestionChoice]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[SurveyQuestionChoice]
GO

CREATE TABLE [dbo].[Survey] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[SurveyName] [varchar] (255) NOT NULL ,
	[SurveyAdministrator] [varchar] (255) NOT NULL ,
	[SurveyAdminEmail] [varchar] (255) NOT NULL ,
	[SurveyAdminTel] [varchar] (50) NOT NULL ,
	[SurveyDescription] [text] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[SurveySection] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[SurveyID] [int] NOT NULL ,
	[SectionName] [varchar] (255) NOT NULL ,
	[SectionOrder] [int] NOT NULL ,
	[SectionDescription] [text] NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[SurveyQuestion] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[SectionID] [int] NOT NULL ,
	[QuestionOrder] [int] NOT NULL ,
	[QuestionTypeID] [int] NOT NULL ,
	[Question] [text] NOT NULL 
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO

CREATE TABLE [dbo].[SurveyQuestionType] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[Name] [varchar] (255) NOT NULL ,
	[Value] [varchar] (3) NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[SurveyChoice] (
	[ID] [int] IDENTITY (1, 1) NOT NULL ,
	[ChoiceDescription] [varchar] (255) NOT NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dbo].[SurveyQuestionChoice] (
	[QuestionID] [int] NOT NULL ,
	[ChoiceID] [int] NOT NULL ,
	[ChoiceOrder] [int] NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[Survey] WITH NOCHECK ADD 
	CONSTRAINT [DF_Survey_SurveyAdministrator] DEFAULT ('Administrator') FOR [SurveyAdministrator],
	CONSTRAINT [DF_Survey_SurveyAdminEmail] DEFAULT ('email') FOR [SurveyAdminEmail],
	CONSTRAINT [DF_Survey_SurveyAdminTel] DEFAULT ('tel') FOR [SurveyAdminTel],
	CONSTRAINT [PK_Survey] PRIMARY KEY  NONCLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[SurveySection] WITH NOCHECK ADD 
	CONSTRAINT [PK_SurveySection] PRIMARY KEY  NONCLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[SurveyQuestion] WITH NOCHECK ADD 
	CONSTRAINT [DF_SurveyQuestion_QuestionType] DEFAULT (1) FOR [QuestionTypeID],
	CONSTRAINT [PK_SurveyQuestion] PRIMARY KEY  NONCLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[SurveyQuestionType] WITH NOCHECK ADD 
	CONSTRAINT [PK_SectionType] PRIMARY KEY  NONCLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[SurveyChoice] WITH NOCHECK ADD 
	CONSTRAINT [PK_SurveyChoice] PRIMARY KEY  NONCLUSTERED 
	(
		[ID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[SurveyQuestionChoice] WITH NOCHECK ADD 
	CONSTRAINT [PK_SurveyQuestionChoice] PRIMARY KEY  CLUSTERED 
	(
		[QuestionID],
		[ChoiceID]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[SurveySection] ADD 
	CONSTRAINT [FK_SurveySection_Survey] FOREIGN KEY 
	(
		[SurveyID]
	) REFERENCES [dbo].[Survey] (
		[ID]
	)
GO

ALTER TABLE [dbo].[SurveyQuestion] ADD 
	CONSTRAINT [FK_SurveyQuestion_QuestionType] FOREIGN KEY 
	(
		[QuestionTypeID]
	) REFERENCES [dbo].[SurveyQuestionType] (
		[ID]
	),
	CONSTRAINT [FK_SurveyQuestion_SurveySection] FOREIGN KEY 
	(
		[SectionID]
	) REFERENCES [dbo].[SurveySection] (
		[ID]
	)
GO

ALTER TABLE [dbo].[SurveyQuestionChoice] ADD 
	CONSTRAINT [FK_SurveyQuestionChoice_SurveyChoice] FOREIGN KEY 
	(
		[ChoiceID]
	) REFERENCES [dbo].[SurveyChoice] (
		[ID]
	),
	CONSTRAINT [FK_SurveyQuestionChoice_SurveyQuestion] FOREIGN KEY 
	(
		[QuestionID]
	) REFERENCES [dbo].[SurveyQuestion] (
		[ID]
	)
GO

INSERT INTO SurveyQuestionType VALUES ('Multiple Choice','mlt')
GO

INSERT INTO SurveyQuestionType VALUES ('Drop-down List','ddl')
GO

INSERT INTO SurveyQuestionType VALUES ('Checkboxes','chk')
GO

INSERT INTO SurveyQuestionType VALUES ('Text (single line)','txt')
GO

INSERT INTO SurveyQuestionType VALUES ('Text (multiple lines)','tta')
GO
